'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _core = require('@babel/core');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BabelCompiler = function () {
    function BabelCompiler(cwd, configs) {
        _classCallCheck(this, BabelCompiler);

        if (BabelCompiler.prototype.instance) return BabelCompiler.prototype.instance;
        BabelCompiler.prototype.instance = this;
        this.current = cwd;
        // get configuration from .babelrc, package.json or wxa.config.js
        this.configs = null;
        try {
            var babelrc = JSON.parse(_fs2.default.readFileSync(_path2.default.join(this.current, '.babelrc'), 'utf-8'));
            this.configs = babelrc;
        } catch (e) {
            var pkg = require(_path2.default.join(this.current, 'package.json'));
            this.configs = pkg.babel || null;
        }

        if (this.configs == null) this.configs = configs.babel || {};
    }

    _createClass(BabelCompiler, [{
        key: 'parse',
        value: function parse(content, configs, opath) {
            if (configs == null) configs = this.configs;
            if (opath && this.checkIgnore(opath, configs.ignore)) {
                return Promise.resolve(content);
            } else {
                try {
                    var rst = (0, _core.transformSync)(content, _extends({}, configs, {
                        filename: opath.base
                    }));
                    return Promise.resolve(rst);
                } catch (e) {
                    return Promise.reject(e);
                }
            }
        }
    }, {
        key: 'checkIgnore',
        value: function checkIgnore(opath, ignore) {
            if (ignore == null) return false;
            var filepath = opath.dir + _path2.default.sep + opath.base;

            if (Array.isArray(ignore)) {
                return ignore.some(function (str) {
                    var reg = (typeof str === 'undefined' ? 'undefined' : _typeof(str)) === 'object' ? str : new RegExp(str);

                    return reg.test(filepath);
                });
            } else {
                var reg = (typeof ignore === 'undefined' ? 'undefined' : _typeof(ignore)) === 'object' ? ignore : new RegExp(ignore);

                return reg.test(filepath);
            }
        }
    }, {
        key: 'mount',
        value: function mount(map) {
            map['js'] = this;
            return map;
        }
    }]);

    return BabelCompiler;
}();

exports.default = BabelCompiler;